<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfADASspnEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfADASspnEvent extends AbstractStructArrayBase
{
    /**
     * The ADASspnEvent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ADASspnEvent[]
     */
    public $ADASspnEvent;
    /**
     * Constructor method for ArrayOfADASspnEvent
     * @uses ArrayOfADASspnEvent::setADASspnEvent()
     * @param \StructType\ADASspnEvent[] $aDASspnEvent
     */
    public function __construct(array $aDASspnEvent = array())
    {
        $this
            ->setADASspnEvent($aDASspnEvent);
    }
    /**
     * Get ADASspnEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ADASspnEvent[]|null
     */
    public function getADASspnEvent()
    {
        return isset($this->ADASspnEvent) ? $this->ADASspnEvent : null;
    }
    /**
     * This method is responsible for validating the values passed to the setADASspnEvent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setADASspnEvent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateADASspnEventForArrayConstraintsFromSetADASspnEvent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfADASspnEventADASspnEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfADASspnEventADASspnEventItem instanceof \StructType\ADASspnEvent) {
                $invalidValues[] = is_object($arrayOfADASspnEventADASspnEventItem) ? get_class($arrayOfADASspnEventADASspnEventItem) : sprintf('%s(%s)', gettype($arrayOfADASspnEventADASspnEventItem), var_export($arrayOfADASspnEventADASspnEventItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ADASspnEvent property can only contain items of type \StructType\ADASspnEvent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ADASspnEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ADASspnEvent[] $aDASspnEvent
     * @return \ArrayType\ArrayOfADASspnEvent
     */
    public function setADASspnEvent(array $aDASspnEvent = array())
    {
        // validation for constraint: array
        if ('' !== ($aDASspnEventArrayErrorMessage = self::validateADASspnEventForArrayConstraintsFromSetADASspnEvent($aDASspnEvent))) {
            throw new \InvalidArgumentException($aDASspnEventArrayErrorMessage, __LINE__);
        }
        if (is_null($aDASspnEvent) || (is_array($aDASspnEvent) && empty($aDASspnEvent))) {
            unset($this->ADASspnEvent);
        } else {
            $this->ADASspnEvent = $aDASspnEvent;
        }
        return $this;
    }
    /**
     * Add item to ADASspnEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\ADASspnEvent $item
     * @return \ArrayType\ArrayOfADASspnEvent
     */
    public function addToADASspnEvent(\StructType\ADASspnEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ADASspnEvent) {
            throw new \InvalidArgumentException(sprintf('The ADASspnEvent property can only contain items of type \StructType\ADASspnEvent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ADASspnEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ADASspnEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ADASspnEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ADASspnEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ADASspnEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ADASspnEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ADASspnEvent
     */
    public function getAttributeName()
    {
        return 'ADASspnEvent';
    }
}
