<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPayments_vehicle ArrayType
 * @subpackage Arrays
 */
class ArrayOfPayments_vehicle extends AbstractStructArrayBase
{
    /**
     * The Payments_vehicle
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Payments_vehicle[]
     */
    public $Payments_vehicle;
    /**
     * Constructor method for ArrayOfPayments_vehicle
     * @uses ArrayOfPayments_vehicle::setPayments_vehicle()
     * @param \StructType\Payments_vehicle[] $payments_vehicle
     */
    public function __construct(array $payments_vehicle = array())
    {
        $this
            ->setPayments_vehicle($payments_vehicle);
    }
    /**
     * Get Payments_vehicle value
     * @return \StructType\Payments_vehicle[]|null
     */
    public function getPayments_vehicle()
    {
        return $this->Payments_vehicle;
    }
    /**
     * This method is responsible for validating the values passed to the setPayments_vehicle method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPayments_vehicle method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePayments_vehicleForArrayConstraintsFromSetPayments_vehicle(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPayments_vehiclePayments_vehicleItem) {
            // validation for constraint: itemType
            if (!$arrayOfPayments_vehiclePayments_vehicleItem instanceof \StructType\Payments_vehicle) {
                $invalidValues[] = is_object($arrayOfPayments_vehiclePayments_vehicleItem) ? get_class($arrayOfPayments_vehiclePayments_vehicleItem) : sprintf('%s(%s)', gettype($arrayOfPayments_vehiclePayments_vehicleItem), var_export($arrayOfPayments_vehiclePayments_vehicleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Payments_vehicle property can only contain items of type \StructType\Payments_vehicle, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Payments_vehicle value
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_vehicle[] $payments_vehicle
     * @return \ArrayType\ArrayOfPayments_vehicle
     */
    public function setPayments_vehicle(array $payments_vehicle = array())
    {
        // validation for constraint: array
        if ('' !== ($payments_vehicleArrayErrorMessage = self::validatePayments_vehicleForArrayConstraintsFromSetPayments_vehicle($payments_vehicle))) {
            throw new \InvalidArgumentException($payments_vehicleArrayErrorMessage, __LINE__);
        }
        $this->Payments_vehicle = $payments_vehicle;
        return $this;
    }
    /**
     * Add item to Payments_vehicle value
     * @throws \InvalidArgumentException
     * @param \StructType\Payments_vehicle $item
     * @return \ArrayType\ArrayOfPayments_vehicle
     */
    public function addToPayments_vehicle(\StructType\Payments_vehicle $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Payments_vehicle) {
            throw new \InvalidArgumentException(sprintf('The Payments_vehicle property can only contain items of type \StructType\Payments_vehicle, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Payments_vehicle[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Payments_vehicle|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Payments_vehicle|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Payments_vehicle|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Payments_vehicle|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Payments_vehicle|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Payments_vehicle
     */
    public function getAttributeName()
    {
        return 'Payments_vehicle';
    }
}
