<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfQuickMessageLog ArrayType
 * @subpackage Arrays
 */
class ArrayOfQuickMessageLog extends AbstractStructArrayBase
{
    /**
     * The QuickMessageLog
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\QuickMessageLog[]
     */
    public $QuickMessageLog;
    /**
     * Constructor method for ArrayOfQuickMessageLog
     * @uses ArrayOfQuickMessageLog::setQuickMessageLog()
     * @param \StructType\QuickMessageLog[] $quickMessageLog
     */
    public function __construct(array $quickMessageLog = array())
    {
        $this
            ->setQuickMessageLog($quickMessageLog);
    }
    /**
     * Get QuickMessageLog value
     * @return \StructType\QuickMessageLog[]|null
     */
    public function getQuickMessageLog()
    {
        return $this->QuickMessageLog;
    }
    /**
     * This method is responsible for validating the values passed to the setQuickMessageLog method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuickMessageLog method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuickMessageLogForArrayConstraintsFromSetQuickMessageLog(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfQuickMessageLogQuickMessageLogItem) {
            // validation for constraint: itemType
            if (!$arrayOfQuickMessageLogQuickMessageLogItem instanceof \StructType\QuickMessageLog) {
                $invalidValues[] = is_object($arrayOfQuickMessageLogQuickMessageLogItem) ? get_class($arrayOfQuickMessageLogQuickMessageLogItem) : sprintf('%s(%s)', gettype($arrayOfQuickMessageLogQuickMessageLogItem), var_export($arrayOfQuickMessageLogQuickMessageLogItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The QuickMessageLog property can only contain items of type \StructType\QuickMessageLog, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set QuickMessageLog value
     * @throws \InvalidArgumentException
     * @param \StructType\QuickMessageLog[] $quickMessageLog
     * @return \ArrayType\ArrayOfQuickMessageLog
     */
    public function setQuickMessageLog(array $quickMessageLog = array())
    {
        // validation for constraint: array
        if ('' !== ($quickMessageLogArrayErrorMessage = self::validateQuickMessageLogForArrayConstraintsFromSetQuickMessageLog($quickMessageLog))) {
            throw new \InvalidArgumentException($quickMessageLogArrayErrorMessage, __LINE__);
        }
        $this->QuickMessageLog = $quickMessageLog;
        return $this;
    }
    /**
     * Add item to QuickMessageLog value
     * @throws \InvalidArgumentException
     * @param \StructType\QuickMessageLog $item
     * @return \ArrayType\ArrayOfQuickMessageLog
     */
    public function addToQuickMessageLog(\StructType\QuickMessageLog $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\QuickMessageLog) {
            throw new \InvalidArgumentException(sprintf('The QuickMessageLog property can only contain items of type \StructType\QuickMessageLog, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->QuickMessageLog[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\QuickMessageLog|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\QuickMessageLog|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\QuickMessageLog|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\QuickMessageLog|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\QuickMessageLog|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string QuickMessageLog
     */
    public function getAttributeName()
    {
        return 'QuickMessageLog';
    }
}
