<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GET_TripsAndPassengersSummary StructType
 * @subpackage Structs
 */
class GET_TripsAndPassengersSummary extends AbstractStructBase
{
    /**
     * The fleetId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $fleetId;
    /**
     * The User
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $User;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The mId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mId;
    /**
     * The UTC_datetime_init
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UTC_datetime_init;
    /**
     * The UTC_datetime_end
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UTC_datetime_end;
    /**
     * Constructor method for GET_TripsAndPassengersSummary
     * @uses GET_TripsAndPassengersSummary::setFleetId()
     * @uses GET_TripsAndPassengersSummary::setUser()
     * @uses GET_TripsAndPassengersSummary::setPassword()
     * @uses GET_TripsAndPassengersSummary::setMId()
     * @uses GET_TripsAndPassengersSummary::setUTC_datetime_init()
     * @uses GET_TripsAndPassengersSummary::setUTC_datetime_end()
     * @param int $fleetId
     * @param string $user
     * @param string $password
     * @param string $mId
     * @param string $uTC_datetime_init
     * @param string $uTC_datetime_end
     */
    public function __construct($fleetId = null, $user = null, $password = null, $mId = null, $uTC_datetime_init = null, $uTC_datetime_end = null)
    {
        $this
            ->setFleetId($fleetId)
            ->setUser($user)
            ->setPassword($password)
            ->setMId($mId)
            ->setUTC_datetime_init($uTC_datetime_init)
            ->setUTC_datetime_end($uTC_datetime_end);
    }
    /**
     * Get fleetId value
     * @return int
     */
    public function getFleetId()
    {
        return $this->fleetId;
    }
    /**
     * Set fleetId value
     * @param int $fleetId
     * @return \StructType\GET_TripsAndPassengersSummary
     */
    public function setFleetId($fleetId = null)
    {
        // validation for constraint: int
        if (!is_null($fleetId) && !(is_int($fleetId) || ctype_digit($fleetId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($fleetId, true), gettype($fleetId)), __LINE__);
        }
        $this->fleetId = $fleetId;
        return $this;
    }
    /**
     * Get User value
     * @return string|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param string $user
     * @return \StructType\GET_TripsAndPassengersSummary
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($user, true), gettype($user)), __LINE__);
        }
        $this->User = $user;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\GET_TripsAndPassengersSummary
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get mId value
     * @return string|null
     */
    public function getMId()
    {
        return $this->mId;
    }
    /**
     * Set mId value
     * @param string $mId
     * @return \StructType\GET_TripsAndPassengersSummary
     */
    public function setMId($mId = null)
    {
        // validation for constraint: string
        if (!is_null($mId) && !is_string($mId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mId, true), gettype($mId)), __LINE__);
        }
        $this->mId = $mId;
        return $this;
    }
    /**
     * Get UTC_datetime_init value
     * @return string|null
     */
    public function getUTC_datetime_init()
    {
        return $this->UTC_datetime_init;
    }
    /**
     * Set UTC_datetime_init value
     * @param string $uTC_datetime_init
     * @return \StructType\GET_TripsAndPassengersSummary
     */
    public function setUTC_datetime_init($uTC_datetime_init = null)
    {
        // validation for constraint: string
        if (!is_null($uTC_datetime_init) && !is_string($uTC_datetime_init)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uTC_datetime_init, true), gettype($uTC_datetime_init)), __LINE__);
        }
        $this->UTC_datetime_init = $uTC_datetime_init;
        return $this;
    }
    /**
     * Get UTC_datetime_end value
     * @return string|null
     */
    public function getUTC_datetime_end()
    {
        return $this->UTC_datetime_end;
    }
    /**
     * Set UTC_datetime_end value
     * @param string $uTC_datetime_end
     * @return \StructType\GET_TripsAndPassengersSummary
     */
    public function setUTC_datetime_end($uTC_datetime_end = null)
    {
        // validation for constraint: string
        if (!is_null($uTC_datetime_end) && !is_string($uTC_datetime_end)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uTC_datetime_end, true), gettype($uTC_datetime_end)), __LINE__);
        }
        $this->UTC_datetime_end = $uTC_datetime_end;
        return $this;
    }
}
