<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MobileInfoWithSpecs StructType
 * @subpackage Structs
 */
class MobileInfoWithSpecs extends AbstractStructBase
{
    /**
     * The mobileInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\MobileInfo
     */
    public $mobileInfo;
    /**
     * The specs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfTag_specs
     */
    public $specs;
    /**
     * Constructor method for MobileInfoWithSpecs
     * @uses MobileInfoWithSpecs::setMobileInfo()
     * @uses MobileInfoWithSpecs::setSpecs()
     * @param \StructType\MobileInfo $mobileInfo
     * @param \ArrayType\ArrayOfTag_specs $specs
     */
    public function __construct(\StructType\MobileInfo $mobileInfo = null, \ArrayType\ArrayOfTag_specs $specs = null)
    {
        $this
            ->setMobileInfo($mobileInfo)
            ->setSpecs($specs);
    }
    /**
     * Get mobileInfo value
     * @return \StructType\MobileInfo
     */
    public function getMobileInfo()
    {
        return $this->mobileInfo;
    }
    /**
     * Set mobileInfo value
     * @param \StructType\MobileInfo $mobileInfo
     * @return \StructType\MobileInfoWithSpecs
     */
    public function setMobileInfo(\StructType\MobileInfo $mobileInfo = null)
    {
        $this->mobileInfo = $mobileInfo;
        return $this;
    }
    /**
     * Get specs value
     * @return \ArrayType\ArrayOfTag_specs|null
     */
    public function getSpecs()
    {
        return $this->specs;
    }
    /**
     * Set specs value
     * @param \ArrayType\ArrayOfTag_specs $specs
     * @return \StructType\MobileInfoWithSpecs
     */
    public function setSpecs(\ArrayType\ArrayOfTag_specs $specs = null)
    {
        $this->specs = $specs;
        return $this;
    }
}
