<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SET_Driver StructType
 * @subpackage Structs
 */
class SET_Driver extends AbstractStructBase
{
    /**
     * The User
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $User;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * The mId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $mId;
    /**
     * The DrvId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DrvId;
    /**
     * Constructor method for SET_Driver
     * @uses SET_Driver::setUser()
     * @uses SET_Driver::setPassword()
     * @uses SET_Driver::setMId()
     * @uses SET_Driver::setDrvId()
     * @param string $user
     * @param string $password
     * @param string $mId
     * @param string $drvId
     */
    public function __construct($user = null, $password = null, $mId = null, $drvId = null)
    {
        $this
            ->setUser($user)
            ->setPassword($password)
            ->setMId($mId)
            ->setDrvId($drvId);
    }
    /**
     * Get User value
     * @return string|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param string $user
     * @return \StructType\SET_Driver
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($user, true), gettype($user)), __LINE__);
        }
        $this->User = $user;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\SET_Driver
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
    /**
     * Get mId value
     * @return string|null
     */
    public function getMId()
    {
        return $this->mId;
    }
    /**
     * Set mId value
     * @param string $mId
     * @return \StructType\SET_Driver
     */
    public function setMId($mId = null)
    {
        // validation for constraint: string
        if (!is_null($mId) && !is_string($mId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mId, true), gettype($mId)), __LINE__);
        }
        $this->mId = $mId;
        return $this;
    }
    /**
     * Get DrvId value
     * @return string|null
     */
    public function getDrvId()
    {
        return $this->DrvId;
    }
    /**
     * Set DrvId value
     * @param string $drvId
     * @return \StructType\SET_Driver
     */
    public function setDrvId($drvId = null)
    {
        // validation for constraint: string
        if (!is_null($drvId) && !is_string($drvId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($drvId, true), gettype($drvId)), __LINE__);
        }
        $this->DrvId = $drvId;
        return $this;
    }
}
