<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SET_InsertDriver StructType
 * @subpackage Structs
 */
class SET_InsertDriver extends AbstractStructBase
{
    /**
     * The Driver
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\Driver
     */
    public $Driver;
    /**
     * The User
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $User;
    /**
     * The Password
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Password;
    /**
     * Constructor method for SET_InsertDriver
     * @uses SET_InsertDriver::setDriver()
     * @uses SET_InsertDriver::setUser()
     * @uses SET_InsertDriver::setPassword()
     * @param \StructType\Driver $driver
     * @param string $user
     * @param string $password
     */
    public function __construct(\StructType\Driver $driver = null, $user = null, $password = null)
    {
        $this
            ->setDriver($driver)
            ->setUser($user)
            ->setPassword($password);
    }
    /**
     * Get Driver value
     * @return \StructType\Driver
     */
    public function getDriver()
    {
        return $this->Driver;
    }
    /**
     * Set Driver value
     * @param \StructType\Driver $driver
     * @return \StructType\SET_InsertDriver
     */
    public function setDriver(\StructType\Driver $driver = null)
    {
        $this->Driver = $driver;
        return $this;
    }
    /**
     * Get User value
     * @return string|null
     */
    public function getUser()
    {
        return $this->User;
    }
    /**
     * Set User value
     * @param string $user
     * @return \StructType\SET_InsertDriver
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($user, true), gettype($user)), __LINE__);
        }
        $this->User = $user;
        return $this;
    }
    /**
     * Get Password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->Password;
    }
    /**
     * Set Password value
     * @param string $password
     * @return \StructType\SET_InsertDriver
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->Password = $password;
        return $this;
    }
}
