<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Specifications StructType
 * @subpackage Structs
 */
class Specifications extends AbstractStructBase
{
    /**
     * The elevator_platform
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $elevator_platform;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The model
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $model;
    /**
     * The color
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $color;
    /**
     * The fuel_type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $fuel_type;
    /**
     * The tank_volume
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $tank_volume;
    /**
     * The volume_unit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $volume_unit;
    /**
     * The engine_cc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $engine_cc;
    /**
     * The width
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $width;
    /**
     * The length
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $length;
    /**
     * The height
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $height;
    /**
     * Constructor method for Specifications
     * @uses Specifications::setElevator_platform()
     * @uses Specifications::setType()
     * @uses Specifications::setModel()
     * @uses Specifications::setColor()
     * @uses Specifications::setFuel_type()
     * @uses Specifications::setTank_volume()
     * @uses Specifications::setVolume_unit()
     * @uses Specifications::setEngine_cc()
     * @uses Specifications::setWidth()
     * @uses Specifications::setLength()
     * @uses Specifications::setHeight()
     * @param string $elevator_platform
     * @param string $type
     * @param string $model
     * @param string $color
     * @param string $fuel_type
     * @param string $tank_volume
     * @param string $volume_unit
     * @param string $engine_cc
     * @param string $width
     * @param string $length
     * @param string $height
     */
    public function __construct($elevator_platform = null, $type = null, $model = null, $color = null, $fuel_type = null, $tank_volume = null, $volume_unit = null, $engine_cc = null, $width = null, $length = null, $height = null)
    {
        $this
            ->setElevator_platform($elevator_platform)
            ->setType($type)
            ->setModel($model)
            ->setColor($color)
            ->setFuel_type($fuel_type)
            ->setTank_volume($tank_volume)
            ->setVolume_unit($volume_unit)
            ->setEngine_cc($engine_cc)
            ->setWidth($width)
            ->setLength($length)
            ->setHeight($height);
    }
    /**
     * Get elevator_platform value
     * @return string|null
     */
    public function getElevator_platform()
    {
        return $this->elevator_platform;
    }
    /**
     * Set elevator_platform value
     * @param string $elevator_platform
     * @return \StructType\Specifications
     */
    public function setElevator_platform($elevator_platform = null)
    {
        // validation for constraint: string
        if (!is_null($elevator_platform) && !is_string($elevator_platform)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($elevator_platform, true), gettype($elevator_platform)), __LINE__);
        }
        $this->elevator_platform = $elevator_platform;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\Specifications
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get model value
     * @return string|null
     */
    public function getModel()
    {
        return $this->model;
    }
    /**
     * Set model value
     * @param string $model
     * @return \StructType\Specifications
     */
    public function setModel($model = null)
    {
        // validation for constraint: string
        if (!is_null($model) && !is_string($model)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($model, true), gettype($model)), __LINE__);
        }
        $this->model = $model;
        return $this;
    }
    /**
     * Get color value
     * @return string|null
     */
    public function getColor()
    {
        return $this->color;
    }
    /**
     * Set color value
     * @param string $color
     * @return \StructType\Specifications
     */
    public function setColor($color = null)
    {
        // validation for constraint: string
        if (!is_null($color) && !is_string($color)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($color, true), gettype($color)), __LINE__);
        }
        $this->color = $color;
        return $this;
    }
    /**
     * Get fuel_type value
     * @return string|null
     */
    public function getFuel_type()
    {
        return $this->fuel_type;
    }
    /**
     * Set fuel_type value
     * @param string $fuel_type
     * @return \StructType\Specifications
     */
    public function setFuel_type($fuel_type = null)
    {
        // validation for constraint: string
        if (!is_null($fuel_type) && !is_string($fuel_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fuel_type, true), gettype($fuel_type)), __LINE__);
        }
        $this->fuel_type = $fuel_type;
        return $this;
    }
    /**
     * Get tank_volume value
     * @return string|null
     */
    public function getTank_volume()
    {
        return $this->tank_volume;
    }
    /**
     * Set tank_volume value
     * @param string $tank_volume
     * @return \StructType\Specifications
     */
    public function setTank_volume($tank_volume = null)
    {
        // validation for constraint: string
        if (!is_null($tank_volume) && !is_string($tank_volume)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tank_volume, true), gettype($tank_volume)), __LINE__);
        }
        $this->tank_volume = $tank_volume;
        return $this;
    }
    /**
     * Get volume_unit value
     * @return string|null
     */
    public function getVolume_unit()
    {
        return $this->volume_unit;
    }
    /**
     * Set volume_unit value
     * @param string $volume_unit
     * @return \StructType\Specifications
     */
    public function setVolume_unit($volume_unit = null)
    {
        // validation for constraint: string
        if (!is_null($volume_unit) && !is_string($volume_unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($volume_unit, true), gettype($volume_unit)), __LINE__);
        }
        $this->volume_unit = $volume_unit;
        return $this;
    }
    /**
     * Get engine_cc value
     * @return string|null
     */
    public function getEngine_cc()
    {
        return $this->engine_cc;
    }
    /**
     * Set engine_cc value
     * @param string $engine_cc
     * @return \StructType\Specifications
     */
    public function setEngine_cc($engine_cc = null)
    {
        // validation for constraint: string
        if (!is_null($engine_cc) && !is_string($engine_cc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($engine_cc, true), gettype($engine_cc)), __LINE__);
        }
        $this->engine_cc = $engine_cc;
        return $this;
    }
    /**
     * Get width value
     * @return string|null
     */
    public function getWidth()
    {
        return $this->width;
    }
    /**
     * Set width value
     * @param string $width
     * @return \StructType\Specifications
     */
    public function setWidth($width = null)
    {
        // validation for constraint: string
        if (!is_null($width) && !is_string($width)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($width, true), gettype($width)), __LINE__);
        }
        $this->width = $width;
        return $this;
    }
    /**
     * Get length value
     * @return string|null
     */
    public function getLength()
    {
        return $this->length;
    }
    /**
     * Set length value
     * @param string $length
     * @return \StructType\Specifications
     */
    public function setLength($length = null)
    {
        // validation for constraint: string
        if (!is_null($length) && !is_string($length)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($length, true), gettype($length)), __LINE__);
        }
        $this->length = $length;
        return $this;
    }
    /**
     * Get height value
     * @return string|null
     */
    public function getHeight()
    {
        return $this->height;
    }
    /**
     * Set height value
     * @param string $height
     * @return \StructType\Specifications
     */
    public function setHeight($height = null)
    {
        // validation for constraint: string
        if (!is_null($height) && !is_string($height)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($height, true), gettype($height)), __LINE__);
        }
        $this->height = $height;
        return $this;
    }
}
